<?php
/*
Author: Ryan Duff
Author URI: http://ryanduff.net
Description: Administrative options for WP-ContractForm
*/

load_plugin_textdomain('wpcontract',$path = 'wp-content/plugins/wp-contract-form');
$location = get_option('siteurl') . '/wp-admin/admin.php?page=wp-contract-form/options-contractform.php'; // Form Action URI

/*Lets add some default options if they don't exist*/
add_option('wpcontract_email', __('you@example.com', 'wpcontract'));
add_option('wpcontract_subject', __('Contract Submission', 'wpcontract'));
add_option('wpcontract_terms', __('<strong>Terms and Conditions</strong><br/>You will do what we tell you to do and will not sue us.<br/>(Please)<br/>', 'wpcontract'));
add_option('wpcontract_agree', __('I have read the above statement and agree to its terms.', 'wpcontract'));
add_option('wpcontract_seed', __('PetsName', 'wpcontract'));
add_option('wpcontract_success_msg', __('You should receive an email soon with your confirmation number.', 'wpcontract'));
add_option('wpcontract_error_msg', __('Please fill in the required fields.', 'wpcontract'));
add_option('wpcontract_show_quicktag', TRUE);

/*check form submission and update options*/
if ('process' == $_POST['stage'])
{
update_option('wpcontract_email', $_POST['wpcontract_email']);
update_option('wpcontract_subject', $_POST['wpcontract_subject']);
update_option('wpcontract_terms', $_POST['wpcontract_terms']);
update_option('wpcontract_agree', $_POST['wpcontract_agree']);
update_option('wpcontract_seed', $_POST['wpcontract_seed']);
update_option('wpcontract_success_msg', $_POST['wpcontract_success_msg']);
update_option('wpcontract_error_msg', $_POST['wpcontract_error_msg']);

if(isset($_POST['wpcontract_show_quicktag'])) // If wpcontract_show_quicktag is checked
	{update_option('wpcontract_show_quicktag', true);}
	else {update_option('wpcontract_show_quicktag', false);}

}

/*Get options for form fields*/
$wpcontract_email = stripslashes(get_option('wpcontract_email'));
$wpcontract_subject = stripslashes(get_option('wpcontract_subject'));
$wpcontract_terms = stripslashes(get_option('wpcontract_terms'));
$wpcontract_agree = stripslashes(get_option('wpcontract_agree'));
$wpcontract_seed = stripslashes(get_option('wpcontract_seed'));
$wpcontract_success_msg = stripslashes(get_option('wpcontract_success_msg'));
$wpcontract_error_msg = stripslashes(get_option('wpcontract_error_msg'));
$wpcontract_show_quicktag = get_option('wpcontract_show_quicktag');
?>

<div class="wrap">
  <h2><?php _e('Contract Form Options', 'wpcontract') ?></h2>
  <form name="form1" method="post" action="<?php echo $location ?>&amp;updated=true">
	<input type="hidden" name="stage" value="process" />
    <table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr valign="top">
        <th scope="row"><?php _e('E-mail Address:') ?></th>
        <td><input name="wpcontract_email" type="text" id="wpcontract_email" value="<?php echo $wpcontract_email; ?>" size="40" />
        <br />
<?php _e('This address is where the email will be sent to.', 'wpcontract') ?></td>
      </tr>
      <tr valign="top">
        <th scope="row"><?php _e('Subject:') ?></th>
        <td><input name="wpcontract_subject" type="text" id="wpcontract_subject" value="<?php echo $wpcontract_subject; ?>" size="50" />
        <br />
<?php _e('This will be the subject of the email.', 'wpcontract') ?></td>
      </tr>
      <tr valign="top">
        <th scope="row"><?php _e('I Agree Prompt:') ?></th>
        <td><input name="wpcontract_agree" type="text" id="wpcontract_agree" value="<?php echo $wpcontract_agree; ?>" size="90" />
        <br />
<?php _e('This will be the agreement checkbox text.', 'wpcontract') ?></td>
      </tr>
      <tr valign="top">
        <th scope="row"><?php _e('Unique Encryption Seed:') ?></th>
        <td><input name="wpcontract_seed" type="text" id="wpcontract_seed" value="<?php echo $wpcontract_seed; ?>" size="7" />
        <br />
<?php _e('A seed that will grow unique contract IDs.', 'wpcontract') ?></td>
      </tr>
     </table>

	<fieldset class="options">
		<legend><?php _e('Messages', 'wpcontract') ?></legend>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		  <tr valign="top">
			<th scope="row"><?php _e('Success Message:', 'wpcontract') ?></th>
			<td><textarea name="wpcontract_success_msg" id="wpcontract_success_msg" style="width: 80%;" rows="4" cols="50"><?php echo $wpcontract_success_msg; ?></textarea>
			<br />
	<?php _e('These are the terms to which the customer is agreeing.', 'wpcontract') ?></td>
		  </tr>
		  <tr valign="top">
			<th scope="row"><?php _e('Terms:', 'wpcontract') ?></th>
			<td><textarea name="wpcontract_terms" id="wpcontract_terms" style="width: 80%;" rows="5" cols="50"><?php echo $wpcontract_terms; ?></textarea>
			<br />
	<?php _e('When the form is sucessfully submitted, this is the message the user will see.', 'wpcontract') ?></td>
		  </tr>
		  <tr valign="top">
			<th scope="row"><?php _e('Error Message:', 'wpcontract') ?></th>
			<td><textarea name="wpcontract_error_msg" id="wpcontract_error_msg" style="width: 80%;" rows="4" cols="50"><?php echo $wpcontract_error_msg; ?></textarea>
			<br />
	<?php _e('If the user skips a required field, this is the message he will see.', 'wpcontract') ?> <br />
	<?php _e('You can apply CSS to this text by wrapping it in <code>&lt;p style="[your CSS here]"&gt; &lt;/p&gt;</code>.', 'wpcontract') ?><br />
	<?php _e('ie. <code>&lt;p style="color:red;"&gt;Please fill in the required fields.&lt;/p&gt;</code>.', 'wpcontract') ?></td>
		  </tr>
		</table>

	</fieldset>

	<fieldset class="options">
		<legend><?php _e('Advanced', 'wpcontract') ?></legend>

	    <table width="100%" cellpadding="5" class="editform">
	      <tr valign="top">
	        <th width="30%" scope="row" style="text-align: left"><?php _e('Show \'Contract Form\' Quicktag', 'wpcontract') ?></th>
	        <td>
	        	<input name="wpcontract_show_quicktag" type="checkbox" id="wpcontract_show_quicktag" value="wpcontract_show_quicktag"
	        	<?php if($wpcontract_show_quicktag == TRUE) {?> checked="checked" <?php } ?> />
			</td>
	      </tr>
	     </table>

	</fieldset>

    <p class="submit">
      <input type="submit" name="submit" value="<?php _e('Update Options', 'wpcontract') ?> &raquo;" />
    </p>
  </form>
</div>