<?php
/*
Plugin Name: WP-ContractForm
Plugin URI: http://www.TheCodeCave.com
Description: WP Contract Form Brian's blatent rip off and hack of Ryan Duff's WP contract Form plugin. It adds terms and an agreement checkbox. It gives the WP User a unique ID
Author: Ryan Duff, Firas Durri. Hacked by Brian Layman
Author URI: http://www.TheCodeCave.com
Version: 0.2
OldPlugin Name: WP-contractForm
OldPlugin URI: http://ryanduff.net/projects/wp-contractform/
OldDescription: WP contract Form is a drop in form for users to contract you. It can be implemented on a page or a post. It currently works with WordPress 2.0+
OldAuthor: Ryan Duff
OldAuthor URI: http://ryanduff.net
OldVersion: 1.4.3

*/


load_plugin_textdomain('wpcontract',$path = 'wp-content/plugins/wp-contract-form');

/*
if (!is_user_logged_in())
  _e('You must be a registered user on this site to use this form.<br/>', 'wpcontract');
  _e('Return to the main page and choose Register or Login. <br/>', 'wpcontract');
  _e('Please remember you must allow TheCodeCave.com to use cookies if you wish to login.<br/>', 'wpcontract');
  die;
*/

/* Declare strings that change depending on input. This also resets them so errors clear on resubmission. */
$wpcontract_strings = array(
	'name' => '<div class="contractright"><input type="text" name="wpcontract_your_name" id="wpcontract_your_name" size="30" maxlength="50" value="' . $_POST['wpcontract_your_name'] . '" /> (' . __('required', 'wpcontract') . ')</div>',
	'email' => '<div class="contractright"><input type="text" name="wpcontract_email" id="wpcontract_email" size="30" maxlength="50" value="' . $_POST['wpcontract_email'] . '" /> (' . __('required', 'wpcontract') . ')</div>',
	'website' => '<div class="contractright"><input type="text" name="wpcontract_website" id="wpcontract_website" size="30" maxlength="100" value="' . $_POST['wpcontract_website'] . '" /> (' . __('required', 'wpcontract') . ')</div>',
	'agree' => '<input type="checkbox" value="1" id="agree" /> (required)',
        'msg' => '<div class="contractright"><textarea name="wpcontract_msg" id="wpcontract_msg" cols="90" rows="8" >' . $_POST['wpcontract_msg'] . '</textarea></div>',
	'error' => '');

/*
This shows the quicktag on the write pages
Based off Buttonsnap Template
http://redalt.com/downloads
*/
if(get_option('wpcontract_show_quicktag') == true) {
	include('buttonsnap.php');

	add_action('init', 'wpcontract_button_init');
	add_action('marker_css', 'wpcontract_marker_css');

	function wpcontract_button_init() {
		$wpcontract_button_url = buttonsnap_dirname(__FILE__) . '/wpcontract_button.png';

		buttonsnap_textbutton($wpcontract_button_url, __('Insert contract Form', 'wpcontract'), '<!--contract form-->');
		buttonsnap_register_marker('contract form', 'wpcontract_marker');
	}

	function wpcontract_marker_css() {
		$wpcontract_marker_url = buttonsnap_dirname(__FILE__) . '/wpcontract_marker.gif';
		echo "
			.wpcontract_marker {
					display: block;
					height: 15px;
					width: 155px
					margin-top: 5px;
					background-image: url({$wpcontract_marker_url});
					background-repeat: no-repeat;
					background-position: center;
			}
		";
	}
}

function wpcontract_is_malicious($input) {
	$is_malicious = false;
	$bad_inputs = array("\r", "\n", "mime-version", "content-type", "cc:", "to:");
	foreach($bad_inputs as $bad_input) {
		if(strpos(strtolower($input), strtolower($bad_input)) !== false) {
			$is_malicious = true; break;
		}
	}
	return $is_malicious;
}

/* This function checks for errors on input and changes $wpcontract_strings if there are any errors. Shortcircuits if there has not been a submission */
function wpcontract_check_input()
{
	if(!(isset($_POST['wpcontract_stage']))) {return false;} // Shortcircuit.
	$_POST['wpcontract_your_name'] = stripslashes(trim($_POST['wpcontract_your_name']));
	$_POST['wpcontract_email'] = stripslashes(trim($_POST['wpcontract_email']));
	$_POST['wpcontract_website'] = stripslashes(trim($_POST['wpcontract_website']));
	$_POST['wpcontract_msg'] = stripslashes(trim($_POST['wpcontract_msg']));
	$_POST['wpcontract_agree'] = stripslashes(trim($_POST['wpcontract_agree']));

	global $wpcontract_strings;
	$ok = true;

	if(empty($_POST['wpcontract_your_name']))
	{
		$ok = false; $reason = 'empty';
		$wpcontract_strings['name'] = '<div class="contractright"><input type="text" name="wpcontract_your_name" id="wpcontract_your_name" size="30" maxlength="50" value="' . $_POST['wpcontract_your_name'] . '" class="contracterror" /> (' . __('required', 'wpcontract') . ')</div>';
	}

	if(!is_email($_POST['wpcontract_email']))
	{
		$ok = false; $reason = 'empty';
		$wpcontract_strings['email'] = '<div class="contractright"><input type="text" name="wpcontract_email" id="wpcontract_email" size="30" maxlength="50" value="' . $_POST['wpcontract_email'] . '" class="contracterror" /> (' . __('required', 'wpcontract') . ')</div>';
	}

	if(empty($_POST['wpcontract_website']))
	{
		$ok = false; $reason = 'empty';
		$wpcontract_strings['email'] = '<div class="contractright"><input type="text" name="wpcontract_website" id="wpcontract_website" size="30" maxlength="50" value="' . $_POST['wpcontract_website'] . '" class="contracterror" /> (' . __('required', 'wpcontract') . ')</div>';
	}

	if(!($_POST['agree'] = "1"))
	{
		$ok = false;
		$wpcontract_strings['agree'] = '<div class="Contractright"><input type="checkbox" value="1" id="agree"  class="Contracterror" > (required)</div>';

	}

	if(wpcontract_is_malicious($_POST['wpcontract_your_name']) || wpcontract_is_malicious($_POST['wpcontract_email'])) {
		$ok = false; $reason = 'malicious';
	}

	if($ok == true)
	{
		return true;
	}
	else {
		if($reason == 'malicious') {
			$wpcontract_strings['error'] = "<div style='font-weight: bold;'>You can not use any of the following in the Name or Email fields: a linebreak, or the phrases 'mime-version', 'content-type', 'cc:' or 'to:'.</div>";
		} elseif($reason == 'empty') {
			$wpcontract_strings['error'] = '<div style="font-weight: bold;">' . stripslashes(get_option('wpcontract_error_msg')) . '</div>';
		}
		return false;
	}
}

/*Wrapper function which calls the form.*/
function wpcontract_callback( $content )
{
	global $wpcontract_strings;

	// Run the input check.

	if(! preg_match('|<!--contract form-->|', $content)) {
		return $content;
	}
    if(wpcontract_check_input()) // If the input check returns true (ie. there has been a submission & input is ok)
    {
            $recipient = get_option('wpcontract_email');
            $subject = get_option('wpcontract_subject');
						$success_msg = get_option('wpcontract_success_msg');
						$success_msg = stripslashes($success_msg);

            $name = $_POST['wpcontract_your_name'];
            $email = $_POST['wpcontract_email'];
            $website = $_POST['wpcontract_website'];
            $msg = $_POST['wpcontract_msg'];

            $headers = "MIME-Version: 1.0\n";
            $headers .= "From: $name <$email>\n";
            $headers .= "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\n";

            $fullmsg = "$name wrote:\n";
            $fullmsg .= wordwrap($msg, 80, "\n") . "\n\n";
            $fullmsg .= "Email: " . $email . "\n";
            $fullmsg .= "Website: " . $website . "\n";
            $fullmsg .= "IP: " . wpcontract_getip() . "\n";
            $fullmsg .= "Contract ID: " . wpcontract_getCID($website) . "\n";
            mail($recipient, $subject, $fullmsg, $headers);

            $headers = "MIME-Version: 1.0\n";
            $headers .= "From: $recipient\n";
            $headers .= "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\n";

            mail($email, $subject, $fullmsg, $headers);

            $results = '<div style="font-weight: bold;">' . $success_msg . '</div>';
            echo $results;
    }
    else // Else show the form. If there are errors the strings will have updated during running the inputcheck.
    {
        $form = '<div class="contractform">
        ' . $wpcontract_strings['error'] . '
        	<form action="' . get_permalink() . '" method="post">
         		<div class="contractleft"><label for="wpcontract_your_name">' . __('Your Name: ', 'wpcontract') . '</label></div>' . $wpcontract_strings['name']  . '<br/>
        		<div class="contractleft"><label for="wpcontract_email">' . __('Your Email:', 'wpcontract') . '</label></div>' . $wpcontract_strings['email'] . '<br/>
        		<div class="contractleft"><label for="wpcontract_website">' . __('Your Website:', 'wpcontract') . '</label></div>' . $wpcontract_strings['website'] . '<br/>
                        <div class="contractterms">' . __(stripslashes(get_option('wpcontract_terms')), 'wpcontract') . '</div>' . '<br/>
        		<div class="contractother"><label for="agree">' . __(stripslashes(get_option("wpcontract_agree")), "wpcontract") . '</label>' . $wpcontract_strings['agree'] .'</div><br/>
            	<div class="contractleft"><label for="wpcontract_msg">' . __('Your Message: ', 'wpcontract') . '</label></div>' . $wpcontract_strings['msg'] . '<br/>
           	<div class="contractleft"><input type="hidden" name="wpcontract_stage" value="process" /></div>
            	<div class="contractother"><input type="submit" name="Submit" value="' . __('Submit', 'wpcontract') . '" id="contractsubmit" /></div></form></div>
        <div style="clear:both; height:1px;">&nbsp;</div>';
        return str_replace('<!--contract form-->', $form, $content);
    }
}

function wpcontract_getCID($site)
{
         echo $site."<br/>";
         echo get_option("wpcontract_seed")."<br/>";
         echo md5($site . get_option("wpcontract_seed"))."<br/>";
         echo substr(md5($site . get_option("wpcontract_seed")), 7, 5) . substr(md5($site . get_option("wpcontract_seed")), -10, 5);
         return substr(md5($site . get_option("wpcontract_seed")), 7, 5) . substr(md5($site . get_option("wpcontract_seed")), -10, 5);
}

/*Can't use WP's function here, so lets use our own*/
function wpcontract_getip()
{
	if (isset($_SERVER))
	{
 		if (isset($_SERVER["HTTP_X_FORWARDED_FOR"]))
 		{
  			$ip_addr = $_SERVER["HTTP_X_FORWARDED_FOR"];
 		}
 		elseif (isset($_SERVER["HTTP_CLIENT_IP"]))
 		{
  			$ip_addr = $_SERVER["HTTP_CLIENT_IP"];
 		}
 		else
 		{
 			$ip_addr = $_SERVER["REMOTE_ADDR"];
 		}
	}
	else
	{
 		if ( getenv( 'HTTP_X_FORWARDED_FOR' ) )
 		{
  			$ip_addr = getenv( 'HTTP_X_FORWARDED_FOR' );
 		}
 		elseif ( getenv( 'HTTP_CLIENT_IP' ) )
 		{
  			$ip_addr = getenv( 'HTTP_CLIENT_IP' );
 		}
 		else
 		{
  			$ip_addr = getenv( 'REMOTE_ADDR' );
 		}
	}
return $ip_addr;
}

function wpcontract_css()
         {
	?>
<style type="text/css" media="screen">

/* Begin contract Form CSS */
.contractform {
	position: static;
	overflow: hidden;
}

.contractleft {
}

.contractright {
}

.contractleft_could_be_used_instead {
	width: 25%;
	text-align: right;
	clear: both;
	float: left;
	display: inline;
	padding: 2px;
	margin: 2px 0;
}

.contractright_could_be_used_instead {
	width: 70%;
	text-align: left;
	float: right;
	display: inline;
	padding: 0px;
	margin: 2px 0;
}

.contractother {
}

.contractterms {
	border: 1px solid #000000;
	padding: 4px;
	margin: 4px 4;
}

.contracterror {
	border: 1px solid #ff0000;
}

.contractsubmit {
}
/* End contract Form CSS */

	</style>

<?php

         }

/*CSS Styling*/

function wpcontract_add_options_page()
	{
		add_options_page('Contract Form Options', 'Contract Form', 'manage_options', 'wp-contract-form/options-contractform.php');
	}

/* Action calls for all functions */

//if(get_option('wpcontract_show_quicktag') == true) {add_action('admin_footer', 'wpcontract_add_quicktag');}

add_action('admin_head', 'wpcontract_add_options_page');
add_filter('wp_head', 'wpcontract_css');
add_filter('the_content', 'wpcontract_callback', 7);

?>
